#include <stdio.h>
#include <stdlib.h>
#include "stackfunctions.h"
#include "newSleep.h"
#define bool int


/* Returns 1 for matching Pairs */

bool isMatchingPair(char one, char two)
{
    if (one == '(' && two == ')')
        return 1;
    else if (one == '{' && two == '}')
        return 1;
    else if (one == '[' && two == ']')
        return 1;
    else
        return 0;
}
 
/* Return 1 for balanced Parenthesis */
bool areParenthesisBalanced(char exp[])
{
    int p = 0;
 
    // Declare an empty character stack
    struct stNode* stack = NULL;
 
    /*checking for matching
     parenthesis */
    while (exp[p]) 
    {
        /* If the exp[i] is a starting parenthesis then push it */
        if (exp[p] == '{' || exp[p] == '(' || exp[p] == '[')
            push(&stack, exp[p]);
 
        // If exp[i] is an ending parenthesis then pop from
        // stack and check if the popped parenthesis is a
        // matching pair*/
        if (exp[p] == '}' || exp[p] == ')'
            || exp[p] == ']') 
        {
 
            /* If we see an ending parenthesis without a pair
             then return false*/
            if (stack == NULL)
                return 0;
 
            /* Pop the top element from stack, if it is not
             a pair parenthesis of character then there is a
             mismatch.
             his happens for expressions like {(}) */
            else if (!isMatchingPair(pop(&stack), exp[p]))
                return 0;
        }
        p++;
    }
 
    /* If there is something left in expression then there
     is a starting parenthesis without a closing
     parenthesis*/
    if (stack == NULL)
        return 1; /*balanced*/
    else
        return 0; /*not balanced*/
}

void newSleep(float sec){
      struct timespec ts;
      ts.tv_sec = (int)sec;
      ts.tv_nsec = (sec -((int)sec))*1000000000;
      nanosleep(&ts, NULL);
      
    }
 
 
/* Main Code */
int main()
{
  
    char exp[50] ;
    FILE *fptr ;
    printf("Enter The File Name To perform bracket-balance-checking? \n");
    scanf("%s",exp);
 
    

    if ((fptr = fopen(exp, "r")) == NULL)
    {
        printf("Error! opening file");
        /* exit from program if file pointer returns NULL.*/
        exit(1);         
    }

    /* read the text until newline */
    fscanf(fptr,"%[^\n]", exp);

    printf("File Contents :\n%s",exp );
    fclose(fptr);
   
    /* Function call */
    if (areParenthesisBalanced(exp))
        printf("All Good \n");
    else
        printf("Not Balanced \n");
    return 0;
}
 
/* Function to push an item to stack*/
void push(struct stNode** top_ref, int new_data)
{
    /* allocate node */
    struct stNode* new_node
        = (struct stNode*)malloc(sizeof(struct stNode));
 
    if (new_node == NULL) 
    {
        printf("Stack overflow n");
        getchar();
        exit(0);
    }
 
    /* put in the data */
    new_node->data = new_data;
 
    // link the old list off the new node 
    new_node->next = (*top_ref);
 
    /*move the head to point to the new node */
    (*top_ref) = new_node;
}
 
/* Function to pop an item from stack */
int pop(struct stNode** top_ref)
{
    char res;
    struct stNode* top;
 
    /* If stack is empty then error */
    if (*top_ref == NULL) 
    {
        printf("Stack overflow n");
        getchar();
        exit(0);
    }
    else
    {
        top = *top_ref;
        res = top->data;
        *top_ref = top->next;
        free(top);
        return res;
    }
}